#!/bin/sh

# Mumble v1.3.3 + Cloudflare "YOUR_DOMAIN_NAME_GOES_HERE" DDNS update
# ** Note that this does not configure any OS firewall rules - you're relying entirely on AWS security groups being made via Terraform outside of this **

# OPTIONAL BUT RECOMMENDED - Set a password that will be required to join the server. Leaving this blank will make the server public.
SERVER_PASSWORD='YOUR_MUMBLE_SERVER_PASSWORD_GOES_HERE'

# Get and extract Mumble v1.3.3

cd ~/
wget https://github.com/mumble-voip/mumble/releases/download/1.3.3/murmur-static_x86-1.3.3.tar.bz2
tar -xf murmur-static_x86-1.3.3.tar.bz2
cd murmur-static_x86-1.3.3/

# OPTIONAL - Manually set DH from 2048 to 4096, manually generate SSL cert with 4096 RSA.
# If you just ignore this, mumble will do it's default DH 2048 and generate an SSL cert with 2048 RSA.

openssl req -x509 -nodes -days 365 -subj '/CN=mumbleserver/O=mumbleserver/C=SG' -newkey rsa:4096 -keyout ssl.key -out ssl.crt
sed -i -e 's/;sslDHParams=@ffdhe2048/sslDHParams=@ffdhe4096/g' murmur.ini
sed -i -e 's/;sslCiphers=EECDH+AESGCM:EDH+aRSA+AESGCM:DHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA:AES256-SHA:AES128-SHA/sslCiphers=EECDH+AESGCM:EDH+aRSA+AESGCM:DHE-RSA-AES256-SHA:AES256-SHA/g' murmur.ini
sed -i -e 's/;sslCert=/sslCert=ssl.crt/g' murmur.ini
sed -i -e 's/;sslKey=/sslKey=ssl.key/g' murmur.ini

# OPTIONAL BUT RECOMMENDED - Set a password that will be required to join the server
sed -i -e "s/serverpassword=/serverpassword=$SERVER_PASSWORD/g" murmur.ini

# Start Mumble server

./murmur.x86 -ini murmur.ini

#### DDNS to update "YOUR_DOMAIN_NAME_GOES_HERE" A record with server IP

DOMAIN_OR_SUBDOMAIN='YOUR_DOMAIN_OR_SUBDOMAIN_GOES_HERE'
ZONE_ID='YOUR_CLOUDFLARE_ZONE_ID_GOES_HERE'
RECORD_ID='YOUR_CLOUDFLARE_RECORD_ID_GOES_HERE'
EMAIL='YOUR_CLOUDFLARE_EMAIL_GOES_HERE'
API_TOKEN='YOUR_CLOUDFLARE_API_TOKEN_GOES_HERE'
ETH=$(curl -s 'http://169.254.169.254/latest/meta-data/public-ipv4')

ipadr=$ETH
curl -X PUT "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/dns_records/$RECORD_ID" \
     -H "X-Auth-Email: $EMAIL" \
     -H "Authorization: Bearer $API_TOKEN" \
     -H "Content-Type: application/json" \
     --data '{"type":"A","name":"'$DOMAIN_OR_SUBDOMAIN'","content":"'${ipadr}'","ttl":1,"proxied":false}'
echo ""
